#ifndef RS232_BASECODE_H_INCLUDED
#define RS232_BASECODE_H_INCLUDED

void UART_init(void);
uint8_t UART_peekchar(void);
uint8_t UART_getchar(void);
void UART_putchar(char z);
void UART_puts(char *s);
void rs232(uint8_t *wert);

//Dieser Code liest eventgesteuert Chars von der seriellen Schnittstelle und muss
//leider global definiert werden. Der namespace dient der Isolierung.
namespace UART_receive_internals {
    #define UART_BUFFER 10
    uint8_t uart_buffer[UART_BUFFER];
    int8_t  uart_count;//  = 0; wird im Communicator gemacht
    uint8_t uart_getc(void)
    {   /* output next char in cache
        */
        if (uart_count == 0) return 0;
        return uart_buffer[--uart_count];
    }

    ISR(SIG_UART_RECV)
    { /* INTERRUPT: receive char from UART and save it the buffer*/
        if (uart_count < UART_BUFFER) uart_buffer[uart_count++] = UDR;
    }
}

#endif // RS232_BASECODE_H_INCLUDED
