#include "../include/InterruptHandler.h"
#include "../include/Standardincludes.h"

#include <avr/interrupt.h>

//NOTE: Alle vectors auf zeile 117 in iom32.h definiert!
//um diese zu finden, einfach dienzeile unterhalb entcommenten
//siehe auch AVRdoc.pdf seite 44 für die tabelle
//#define TIMER2_COMP_vect                _VECTOR(3)

InterruptHandlerObj::InterruptHandlerObj()
{
    cli();
}

InterruptHandlerObj::~InterruptHandlerObj()
{
    cli();
}

void InterruptHandlerObj::EnableInterrupts()
{
    sei();
}

void InterruptHandlerObj::Disableinterrupts()
{
    cli();
}

int InterruptHandlerObj::SafeExecution(void* toExecute)
{
    //TODO: Parameter ermöglichen
    //FIXME: toExecute cannot be used as a function?!
    uint8_t tmp_sreg;  // temporaerer Speicher fuer das Statusregister
    tmp_sreg = SREG;   // Statusregister (also auch das I-Flag darin) sichern
    cli();             // Interrupts global deaktivieren
    //toExecute();
    SREG = tmp_sreg;     // Status-Register wieder herstellen
    return 0;
}

//http://www.nongnu.org/avr-libc/user-manual/group__avr__interrupts.html
//http://www.mikrocontroller.net/articles/AVR-GCC-Tutorial#Programmieren_mit_Interrupts
