#include "../include/Standardincludes.h"

//Definitionen für Leds
#define LED_ON(LED)	(PORTD |=  (1<<(LED)))
#define LED_OFF(LED)	(PORTD &= ~(1<<(LED)))
#define LED_TOGGLE(LED)	(PORTD ^=  (1<<(LED)))
#define LED1		PD6
#define LED2		PD5


#include "../include/LEDControllerObj.h"
#include "../include/Standardincludes.h"


LEDControllerObj::LEDControllerObj()
{
    DDRD |= (1<<LED1) | (1<<LED2); // Port D: Ausgang für LED1 und LED2
}

LEDControllerObj::~LEDControllerObj()
{
    //dtor
}

void LEDControllerObj::toggleLED1()
{
    LED_TOGGLE(LED1);
}
void LEDControllerObj::toggleLED2()
{
    LED_TOGGLE(LED2);
}

void LEDControllerObj::switchOnLED1()
{
    LED_ON(LED1);
}
void LEDControllerObj::switchOnLED2()
{
    LED_ON(LED2);
}

void LEDControllerObj::switchOffLED1()
{
    LED_OFF(LED1);
}
void LEDControllerObj::switchOffLED2()
{
    LED_OFF(LED2);
}

//Blinken für time. LED1_enable bzw LED2_enable zeigen welche LEDs blinken sollen.
void LEDControllerObj::blink(const int time, const int howmany, bool LED1_enable, bool LED2_enable)
{
    //TODO: Delays of MCControllObj umlenken
    for (int i = 0; i < howmany; ++i)
    {
        _delay_ms(time/2);
        if(LED1_enable)
        {
            LED_ON(LED1);
        }
        if(LED2_enable)
        {
            LED_ON(LED2);
        }
        _delay_ms(time/2);
        LED_OFF(LED1);
        LED_OFF(LED2);
    }
}
