#include "../include/RFControllerObj.h"

#include "../include/Standardincludes.h"
#include "../smallib/global.h"
#include "../smallib/rf12.h"


RFControllerObj::RFControllerObj()
{
    rf12_init();					// ein paar Register setzen (z.B. CLK auf 10MHz)
	rf12_setfreq(RF12FREQ(433.92));	// Sende/Empfangsfrequenz auf 433,92MHz einstellen
	rf12_setbandwidth(4, 1, 4);		// 200kHz Bandbreite, -6dB Verstärkung, DRSSI threshold: -79dBm
	rf12_setbaud(19200);			// 19200 baud
	rf12_setpower(0, 6);			// 1mW Ausgangangsleistung, 120kHz Frequenzshift

}

RFControllerObj::~RFControllerObj()
{
    //dtor
}

unsigned char* RFControllerObj::recieve(int bufferSize)
{
    unsigned char *dataIN[bufferSize];
    rf12_ready();                       //warten bis fertig
	rf12_rxdata(*dataIN,bufferSize); //die funktion nutzt dataIN weiter, dh muss dies returnt werden.
	return *dataIN;
}

void RFControllerObj::send(unsigned char* toSend, int bufferSize)
{
    rf12_txdata(toSend,bufferSize);
}

