#include "../include/TestingObj.h"

TestingObj::TestingObj(LEDControllerObj *newLEDCtrl,
                        SwitchControllerObj *newSwitchCtrl,
                        RS232CommunicatorObj *newSerialConnect,
                        MCControllObj *newMCC,
                        RFControllerObj *newRFController)
{
    LEDCtrl = newLEDCtrl;
    SwitchCtrl = newSwitchCtrl;
    SerialConnect = newSerialConnect;
    MCC = newMCC;
    RFController = newRFController;
}

TestingObj::~TestingObj()
{
    //dtor
}


/***Diese Funktion prüft, ob etwas gesendet werden kann, sollte am PC geprüft werden.*/
bool TestingObj::Test_RS232_Send()
{
    SerialConnect->sendToPC((char*) "Sendtest.\n");
    return true;
}

/***Diese Funktion empfängt maximal 100 chars und sendet sie zurück.*/
bool TestingObj::Test_RS232_Receive()
{
    char* incoming = (char*) malloc(100 * sizeof(char));
    incoming = SerialConnect->receiveFromPC();
    SerialConnect->sendToPC((char*) "Received and did not crash!\n");
    SerialConnect->sendToPC(incoming);
    free(incoming);
    return true;
}

/***Diese Funktion sendet dauerhaft eine Nachricht. Sie returnt nicht!*/
//FIXME: warum wird nichts gesendet?
bool TestingObj::Test_RF_Send()
{
    unsigned char toSend[] = "HELLO";

    while(1)
    {
        //TODO: seems to crash
        //RFController.send(toSend, sizeof(toSend) / sizeof(toSend));
        RFController->send(toSend, strlen((const char*)toSend) * sizeof(char)); //FIXME: funktioniert neue längenberechnung?
        MCC->delay(10);
        //LEDCtrl->blink(50, 1, false, true);
        SerialConnect->sendToPC((char*) "Sent!\n");
    }

    return true;
}

/***Diese Funktion empfängt 32 bytes und sendet sie an den PC. Sie returnt nicht!*/
bool TestingObj::Test_RF_Receive()
{
    while(1)
    {
        char* recv;
        recv = (char*) RFController->recieve(8);
        SerialConnect->sendToPC((char*) "Received:\n");
        SerialConnect->sendToPC(recv);
    }
    return true;
}

/***Diese Funktion probiert auf Knopfdruck eine andere sende/empfangskombination aus. Dazu werden GAIN
und AFC Bits geändert. Quelle: http://www.mikrocontroller.net/articles/RFM12#RFM_empf.C3.A4ngt_nur_M.C3.BCll*/
bool TestingObj::Test_RF_BitCheck()
{
    return true;
}


